unit bmf_fetch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  BMFHEADER=#$E1#$E6#$D5#$1A;
type
  TBmChar=record
    w,h:byte;
    relx,rely:shortint;
    shift:shortint;
    d:pointer;
  end;  {TBmChar}
  TRGB=record
    r,g,b:byte;
  end;  {TRGB}
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ScrollBar1: TScrollBar;
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
    usedcolors,highestcolor:byte;
    rgb:array[byte] of TRGB;
    tablo:array[char] of TBmChar;
  public
    lineheight,zoom:byte;
    sizeover,sizeunder,addspace,sizeinner:shortint;
    x,y:integer;
    function rgbvalue(i:byte):longint;
    procedure Load(s:string);
    procedure free;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
var i,j,k:integer;
begin
  Canvas.Brush.Color:=0;
  Canvas.FillRect(Rect(0,0,Width,Height));
  x:=32; y:=32;
  for k:=1 to length(Edit1.Text) do with tablo[Edit1.Text[k]] do begin
    for j:=0 to pred(h) do
      for i:=0 to pred(w) do begin
        Canvas.Brush.Color:=rgbvalue(byte(ptr(integer(d)+j*w+i)^));
        Canvas.FillRect(Rect(x+(relx+i)*zoom,y+(rely+j)*zoom,x+succ(relx+i)*zoom,y+succ(rely+j)*zoom));
        //Canvas.Pixels[x+relx+i,y+rely+j]:=rgbvalue(byte(ptr(integer(d)+j*w+i)^));
      end;
    inc(x,(shift+addspace)*zoom);
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Activate;
end;

function TForm1.rgbvalue(i:byte):longint;
begin
  result:=rgb[i].b shl 16 or rgb[i].g shl 8 or rgb[i].r;
end;

procedure TForm1.Load(s:string);
var
  f:file;
  c:char;
  i:integer;
begin
  assignfile(f,s);
  FileMode:=0;
  reset(f,1);
  if (s='') or (IOResult<>0) then exit;
  free;
  s:='    '; blockread(f,s[1],4);
  if s=BMFHEADER then begin
    blockread(f,i,1);
    blockread(f,lineheight,1);
    blockread(f,sizeover,1);
    blockread(f,sizeunder,1);
    blockread(f,addspace,1);
    blockread(f,sizeinner,1);
    blockread(f,usedcolors,1);
    blockread(f,highestcolor,1);
    blockread(f,s[1],5);
    for i:=1 to ord(s[5]) do begin
      blockread(f,rgb[i],3);
      rgb[i].r:=rgb[i].r shl 2+3;
      rgb[i].g:=rgb[i].g shl 2+3;
      rgb[i].b:=rgb[i].b shl 2+3;
    end;
    blockread(f,i,1); i:=byte(i); s:='';
    while i>0 do begin
      blockread(f,c,1);
      s:=s+c;
      dec(i);
    end;
    blockread(f,i,2);
    for i:=pred(i) downto 0 do begin
      blockread(f,c,1);
      blockread(f,tablo[c],5);
      with tablo[c] do
        if w or h<>0 then begin
          getmem(d,w*h);
          blockread(f,d^,w*h);
        end;
    end;
  end;
  closefile(f);
  zoom:=ScrollBar1.Position;
  Edit1.Text:=s;
//  Edit1.SetFocus;
end;

procedure TForm1.free;
var c:char;
begin
  for c:=#0 to #255 do with tablo[c] do begin
    if w or h<>0 then freemem(d,w*h);
    w:=0; h:=0;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  free;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case key of
  '+': inc(zoom);
  '-': dec(zoom);
  end;
  Activate;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then Activate;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then begin
      Load(FileName);
      Activate;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir:='.';
  if FileExists(paramstr(1)) then begin
    OpenDialog1.FileName:=paramstr(1);
    Load(paramstr(1));
    Activate;
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  zoom:=ScrollBar1.Position;
  Activate;
//  Edit1.SetFocus;
end;

procedure TForm1.FormDblClick(Sender: TObject);
var
  f:file;
  buf:string[16];
  i,j:integer;
begin
  assignfile(f,OpenDialog1.FileName);
  FileMode:=1;
  rewrite(f,1);
  buf:=BMFHEADER;
  blockwrite(f,buf[1],4);
  i:=$11; blockwrite(f,i,1);
  blockwrite(f,lineheight,1);
  blockwrite(f,sizeover,1);
  blockwrite(f,sizeunder,1);
  blockwrite(f,addspace,1);
  blockwrite(f,sizeinner,1);
  blockwrite(f,usedcolors,1);
  blockwrite(f,highestcolor,1);
  i:=0; blockwrite(f,i,4);
  i:=usedcolors-1; blockwrite(f,i,1);
  for j:=1 to usedcolors do begin
    rgb[j].r:=rgb[j].r shr 2;
    rgb[j].g:=rgb[j].g shr 2;
    rgb[j].b:=rgb[j].b shr 2;
    blockwrite(f,rgb[j],3);
  end;
  i:=length(Edit1.Text); blockwrite(f,i,1);
  blockwrite(f,Edit1.Text[1],i);
  i:=0;
  for j:=0 to 255 do with tablo[char(j)] do
    if (w or h<>0) or (shift<>0) then inc(i);
  blockwrite(f,i,2);
  for j:=0 to 255 do with tablo[char(j)] do
    if (w or h<>0) or (shift<>0) then begin
      blockwrite(f,j,1);
      blockwrite(f,tablo[char(j)],5);
      if w*h<>0 then blockwrite(f,d^,w*h);
    end;
  closefile(f);
end;

end.
